<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Louvain Algorithm: src/graph.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Louvain Algorithm
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">graph.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="graph_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> ============================================================================</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> Name        : graph.h</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> Author      : Buratto Alessandro</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> ============================================================================</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef GRAPH_H_</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#define GRAPH_H_</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;</div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#define MAX_NODES 100000</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="structgnode__t.html#ad4d311cdd7c7af32c709bf31e85a6491">   24</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code" href="structgnode__t.html">gnode_t</a> {<span class="keywordtype">int</span> <a class="code" href="structgnode__t.html#aacbddc80fd409b71eb96b74694c9e962">dest</a>; <span class="keyword">struct </span><a class="code" href="structgnode__t.html">gnode_t</a> * <a class="code" href="structgnode__t.html#acad7921625f7ae519d99ba48df283431">next</a>; <span class="keywordtype">int</span> <a class="code" href="structgnode__t.html#ad4d311cdd7c7af32c709bf31e85a6491">weight</a>;} <a class="code" href="graph_8h.html#a01bbf2d3f333d81f684ee814292b42b2">gnode_t</a>;</div><div class="line"><a name="l00025"></a><span class="lineno"><a class="line" href="structgraph__t.html#abbb80c8116f7827008b888801d738517">   25</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code" href="structgraph__t.html">graph_t</a> {<a class="code" href="structgnode__t.html">gnode_t</a> ** <a class="code" href="structgraph__t.html#abbb80c8116f7827008b888801d738517">vertices</a>; <span class="keywordtype">int</span> <a class="code" href="graph_8h.html#aa06aa604e7ce71847f52d0225ecc43d0">num_vertices</a>, <a class="code" href="graph_8h.html#a16b6212a05e5662ccfd37199d50c637a">num_edges</a>, tot_link_weight;} <a class="code" href="graph_8h.html#a595dd93a0717173364e453106ddb452b">graph_t</a>;</div><div class="line"><a name="l00026"></a><span class="lineno"><a class="line" href="structedge__t.html#ac3f62b86fd1d0ed23de0ec75ea3967e8">   26</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code" href="structedge__t.html">edge_t</a> {<span class="keywordtype">int</span> src, <a class="code" href="structgnode__t.html#aacbddc80fd409b71eb96b74694c9e962">dest</a>, <a class="code" href="structedge__t.html#ac3f62b86fd1d0ed23de0ec75ea3967e8">weight</a>;} <a class="code" href="graph_8h.html#abbf769d3c3cb1aa4496b8671ace4075c">edge_t</a>;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<a class="code" href="structgraph__t.html">graph_t</a> * <a class="code" href="graph_8h.html#aa4a2c58cf35124509c40dea83129ac93">create_graph</a>(<a class="code" href="structedge__t.html">edge_t</a> * edges, <span class="keywordtype">int</span> n);</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="keywordtype">int</span> <a class="code" href="graph_8h.html#aa06aa604e7ce71847f52d0225ecc43d0">num_vertices</a>(<a class="code" href="structgraph__t.html">graph_t</a> * g);</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="keywordtype">int</span> <a class="code" href="graph_8h.html#a16b6212a05e5662ccfd37199d50c637a">num_edges</a>(<a class="code" href="structgraph__t.html">graph_t</a> * g);</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keywordtype">void</span> <a class="code" href="graph_8h.html#a1894d26ea89ef5de84d17c3c2befd70c">print_graph</a>(<a class="code" href="structgraph__t.html">graph_t</a> *);</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="keywordtype">int</span> <a class="code" href="graph_8h.html#a9d32135f75dc83ddf7f04ebedc915239">degree</a>(<a class="code" href="structgraph__t.html">graph_t</a> * g, <span class="keywordtype">int</span> node_id);</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="keywordtype">void</span> <a class="code" href="graph_8h.html#a060b402e39855ced428216b327b030a5">add_edge</a>(<a class="code" href="structgraph__t.html">graph_t</a> * g, <a class="code" href="structedge__t.html">edge_t</a> e);</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="keywordtype">void</span> <a class="code" href="graph_8h.html#a564fd8433c014fded5dfe9b0d5f9aa30">remove_edge</a>(<a class="code" href="structgraph__t.html">graph_t</a> * g, <a class="code" href="structedge__t.html">edge_t</a> e);</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="keywordtype">void</span> <a class="code" href="graph_8h.html#a151f5b250afc78268f7034af24a8f40f">clean_graph</a>(<a class="code" href="structgraph__t.html">graph_t</a> * g);</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* GRAPH_H_ */</span><span class="preprocessor"></span></div><div class="ttc" id="graph_8h_html_aa4a2c58cf35124509c40dea83129ac93"><div class="ttname"><a href="graph_8h.html#aa4a2c58cf35124509c40dea83129ac93">create_graph</a></div><div class="ttdeci">graph_t * create_graph(edge_t *edges, int n)</div><div class="ttdef"><b>Definition:</b> graph.c:76</div></div>
<div class="ttc" id="structedge__t_html"><div class="ttname"><a href="structedge__t.html">edge_t</a></div><div class="ttdef"><b>Definition:</b> graph.h:26</div></div>
<div class="ttc" id="structgnode__t_html"><div class="ttname"><a href="structgnode__t.html">gnode_t</a></div><div class="ttdef"><b>Definition:</b> graph.h:24</div></div>
<div class="ttc" id="graph_8h_html_a16b6212a05e5662ccfd37199d50c637a"><div class="ttname"><a href="graph_8h.html#a16b6212a05e5662ccfd37199d50c637a">num_edges</a></div><div class="ttdeci">int num_edges(graph_t *g)</div><div class="ttdef"><b>Definition:</b> graph.c:104</div></div>
<div class="ttc" id="structgnode__t_html_aacbddc80fd409b71eb96b74694c9e962"><div class="ttname"><a href="structgnode__t.html#aacbddc80fd409b71eb96b74694c9e962">gnode_t::dest</a></div><div class="ttdeci">int dest</div><div class="ttdef"><b>Definition:</b> graph.h:24</div></div>
<div class="ttc" id="graph_8h_html_aa06aa604e7ce71847f52d0225ecc43d0"><div class="ttname"><a href="graph_8h.html#aa06aa604e7ce71847f52d0225ecc43d0">num_vertices</a></div><div class="ttdeci">int num_vertices(graph_t *g)</div><div class="ttdef"><b>Definition:</b> graph.c:113</div></div>
<div class="ttc" id="graph_8h_html_a151f5b250afc78268f7034af24a8f40f"><div class="ttname"><a href="graph_8h.html#a151f5b250afc78268f7034af24a8f40f">clean_graph</a></div><div class="ttdeci">void clean_graph(graph_t *g)</div><div class="ttdef"><b>Definition:</b> graph.c:211</div></div>
<div class="ttc" id="structgnode__t_html_acad7921625f7ae519d99ba48df283431"><div class="ttname"><a href="structgnode__t.html#acad7921625f7ae519d99ba48df283431">gnode_t::next</a></div><div class="ttdeci">struct gnode_t * next</div><div class="ttdef"><b>Definition:</b> graph.h:24</div></div>
<div class="ttc" id="graph_8h_html_a564fd8433c014fded5dfe9b0d5f9aa30"><div class="ttname"><a href="graph_8h.html#a564fd8433c014fded5dfe9b0d5f9aa30">remove_edge</a></div><div class="ttdeci">void remove_edge(graph_t *g, edge_t e)</div><div class="ttdef"><b>Definition:</b> graph.c:184</div></div>
<div class="ttc" id="structgraph__t_html_abbb80c8116f7827008b888801d738517"><div class="ttname"><a href="structgraph__t.html#abbb80c8116f7827008b888801d738517">graph_t::vertices</a></div><div class="ttdeci">gnode_t ** vertices</div><div class="ttdef"><b>Definition:</b> graph.h:25</div></div>
<div class="ttc" id="graph_8h_html_a01bbf2d3f333d81f684ee814292b42b2"><div class="ttname"><a href="graph_8h.html#a01bbf2d3f333d81f684ee814292b42b2">gnode_t</a></div><div class="ttdeci">struct gnode_t gnode_t</div></div>
<div class="ttc" id="graph_8h_html_a060b402e39855ced428216b327b030a5"><div class="ttname"><a href="graph_8h.html#a060b402e39855ced428216b327b030a5">add_edge</a></div><div class="ttdeci">void add_edge(graph_t *g, edge_t e)</div><div class="ttdef"><b>Definition:</b> graph.c:140</div></div>
<div class="ttc" id="graph_8h_html_a1894d26ea89ef5de84d17c3c2befd70c"><div class="ttname"><a href="graph_8h.html#a1894d26ea89ef5de84d17c3c2befd70c">print_graph</a></div><div class="ttdeci">void print_graph(graph_t *)</div><div class="ttdef"><b>Definition:</b> graph.c:236</div></div>
<div class="ttc" id="structgraph__t_html"><div class="ttname"><a href="structgraph__t.html">graph_t</a></div><div class="ttdef"><b>Definition:</b> graph.h:25</div></div>
<div class="ttc" id="structedge__t_html_ac3f62b86fd1d0ed23de0ec75ea3967e8"><div class="ttname"><a href="structedge__t.html#ac3f62b86fd1d0ed23de0ec75ea3967e8">edge_t::weight</a></div><div class="ttdeci">int weight</div><div class="ttdef"><b>Definition:</b> graph.h:26</div></div>
<div class="ttc" id="structgnode__t_html_ad4d311cdd7c7af32c709bf31e85a6491"><div class="ttname"><a href="structgnode__t.html#ad4d311cdd7c7af32c709bf31e85a6491">gnode_t::weight</a></div><div class="ttdeci">int weight</div><div class="ttdef"><b>Definition:</b> graph.h:24</div></div>
<div class="ttc" id="graph_8h_html_a595dd93a0717173364e453106ddb452b"><div class="ttname"><a href="graph_8h.html#a595dd93a0717173364e453106ddb452b">graph_t</a></div><div class="ttdeci">struct graph_t graph_t</div></div>
<div class="ttc" id="graph_8h_html_a9d32135f75dc83ddf7f04ebedc915239"><div class="ttname"><a href="graph_8h.html#a9d32135f75dc83ddf7f04ebedc915239">degree</a></div><div class="ttdeci">int degree(graph_t *g, int node_id)</div><div class="ttdef"><b>Definition:</b> graph.c:124</div></div>
<div class="ttc" id="graph_8h_html_abbf769d3c3cb1aa4496b8671ace4075c"><div class="ttname"><a href="graph_8h.html#abbf769d3c3cb1aa4496b8671ace4075c">edge_t</a></div><div class="ttdeci">struct edge_t edge_t</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
